/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the VerticaStorageRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &VerticaStorageRequest{}

// VerticaStorageRequest struct for VerticaStorageRequest
type VerticaStorageRequest struct {
	Label   *string `json:"label,omitempty"`
	Type    *string `json:"type,omitempty"`
	OAuthId *int32  `json:"o_auth_id,omitempty"`
}

// NewVerticaStorageRequest instantiates a new VerticaStorageRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewVerticaStorageRequest() *VerticaStorageRequest {
	this := VerticaStorageRequest{}
	return &this
}

// NewVerticaStorageRequestWithDefaults instantiates a new VerticaStorageRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewVerticaStorageRequestWithDefaults() *VerticaStorageRequest {
	this := VerticaStorageRequest{}
	return &this
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *VerticaStorageRequest) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *VerticaStorageRequest) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *VerticaStorageRequest) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *VerticaStorageRequest) SetLabel(v string) {
	o.Label = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *VerticaStorageRequest) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *VerticaStorageRequest) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *VerticaStorageRequest) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *VerticaStorageRequest) SetType(v string) {
	o.Type = &v
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *VerticaStorageRequest) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *VerticaStorageRequest) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *VerticaStorageRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *VerticaStorageRequest) SetOAuthId(v int32) {
	o.OAuthId = &v
}

func (o VerticaStorageRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o VerticaStorageRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	return toSerialize, nil
}

type NullableVerticaStorageRequest struct {
	value *VerticaStorageRequest
	isSet bool
}

func (v NullableVerticaStorageRequest) Get() *VerticaStorageRequest {
	return v.value
}

func (v *NullableVerticaStorageRequest) Set(val *VerticaStorageRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableVerticaStorageRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableVerticaStorageRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableVerticaStorageRequest(val *VerticaStorageRequest) *NullableVerticaStorageRequest {
	return &NullableVerticaStorageRequest{value: val, isSet: true}
}

func (v NullableVerticaStorageRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableVerticaStorageRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
